/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
)

// checks if the GroupMailProperties type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &GroupMailProperties{}

// GroupMailProperties struct for GroupMailProperties
type GroupMailProperties struct {
	Id                             NullableString             `json:"id,omitempty"`
	AllowAuthenticatedMessagesOnly *bool                      `json:"allowAuthenticatedMessagesOnly,omitempty"`
	EnableArchive                  *bool                      `json:"enableArchive,omitempty"`
	DeliveryFailureReport          *DeliveryFailureReportType `json:"deliveryFailureReport,omitempty"`
	GroupId                        NullableString             `json:"groupId,omitempty"`
	PrimaryMailAlias               NullableString             `json:"primaryMailAlias,omitempty"`
	GroupsAllowedToPost            []GroupInfo                `json:"groupsAllowedToPost,omitempty"`
	IdentitiesAllowedToPost        []IdentityInfo             `json:"identitiesAllowedToPost,omitempty"`
	MailAliases                    []string                   `json:"mailAliases,omitempty"`
}

// NewGroupMailProperties instantiates a new GroupMailProperties object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGroupMailProperties() *GroupMailProperties {
	this := GroupMailProperties{}
	return &this
}

// NewGroupMailPropertiesWithDefaults instantiates a new GroupMailProperties object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGroupMailPropertiesWithDefaults() *GroupMailProperties {
	this := GroupMailProperties{}
	return &this
}

// GetId returns the Id field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *GroupMailProperties) GetId() string {
	if o == nil || IsNil(o.Id.Get()) {
		var ret string
		return ret
	}
	return *o.Id.Get()
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *GroupMailProperties) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Id.Get(), o.Id.IsSet()
}

// HasId returns a boolean if a field has been set.
func (o *GroupMailProperties) HasId() bool {
	if o != nil && o.Id.IsSet() {
		return true
	}

	return false
}

// SetId gets a reference to the given NullableString and assigns it to the Id field.
func (o *GroupMailProperties) SetId(v string) {
	o.Id.Set(&v)
}

// SetIdNil sets the value for Id to be an explicit nil
func (o *GroupMailProperties) SetIdNil() {
	o.Id.Set(nil)
}

// UnsetId ensures that no value is present for Id, not even an explicit nil
func (o *GroupMailProperties) UnsetId() {
	o.Id.Unset()
}

// GetAllowAuthenticatedMessagesOnly returns the AllowAuthenticatedMessagesOnly field value if set, zero value otherwise.
func (o *GroupMailProperties) GetAllowAuthenticatedMessagesOnly() bool {
	if o == nil || IsNil(o.AllowAuthenticatedMessagesOnly) {
		var ret bool
		return ret
	}
	return *o.AllowAuthenticatedMessagesOnly
}

// GetAllowAuthenticatedMessagesOnlyOk returns a tuple with the AllowAuthenticatedMessagesOnly field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GroupMailProperties) GetAllowAuthenticatedMessagesOnlyOk() (*bool, bool) {
	if o == nil || IsNil(o.AllowAuthenticatedMessagesOnly) {
		return nil, false
	}
	return o.AllowAuthenticatedMessagesOnly, true
}

// HasAllowAuthenticatedMessagesOnly returns a boolean if a field has been set.
func (o *GroupMailProperties) HasAllowAuthenticatedMessagesOnly() bool {
	if o != nil && !IsNil(o.AllowAuthenticatedMessagesOnly) {
		return true
	}

	return false
}

// SetAllowAuthenticatedMessagesOnly gets a reference to the given bool and assigns it to the AllowAuthenticatedMessagesOnly field.
func (o *GroupMailProperties) SetAllowAuthenticatedMessagesOnly(v bool) {
	o.AllowAuthenticatedMessagesOnly = &v
}

// GetEnableArchive returns the EnableArchive field value if set, zero value otherwise.
func (o *GroupMailProperties) GetEnableArchive() bool {
	if o == nil || IsNil(o.EnableArchive) {
		var ret bool
		return ret
	}
	return *o.EnableArchive
}

// GetEnableArchiveOk returns a tuple with the EnableArchive field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GroupMailProperties) GetEnableArchiveOk() (*bool, bool) {
	if o == nil || IsNil(o.EnableArchive) {
		return nil, false
	}
	return o.EnableArchive, true
}

// HasEnableArchive returns a boolean if a field has been set.
func (o *GroupMailProperties) HasEnableArchive() bool {
	if o != nil && !IsNil(o.EnableArchive) {
		return true
	}

	return false
}

// SetEnableArchive gets a reference to the given bool and assigns it to the EnableArchive field.
func (o *GroupMailProperties) SetEnableArchive(v bool) {
	o.EnableArchive = &v
}

// GetDeliveryFailureReport returns the DeliveryFailureReport field value if set, zero value otherwise.
func (o *GroupMailProperties) GetDeliveryFailureReport() DeliveryFailureReportType {
	if o == nil || IsNil(o.DeliveryFailureReport) {
		var ret DeliveryFailureReportType
		return ret
	}
	return *o.DeliveryFailureReport
}

// GetDeliveryFailureReportOk returns a tuple with the DeliveryFailureReport field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GroupMailProperties) GetDeliveryFailureReportOk() (*DeliveryFailureReportType, bool) {
	if o == nil || IsNil(o.DeliveryFailureReport) {
		return nil, false
	}
	return o.DeliveryFailureReport, true
}

// HasDeliveryFailureReport returns a boolean if a field has been set.
func (o *GroupMailProperties) HasDeliveryFailureReport() bool {
	if o != nil && !IsNil(o.DeliveryFailureReport) {
		return true
	}

	return false
}

// SetDeliveryFailureReport gets a reference to the given DeliveryFailureReportType and assigns it to the DeliveryFailureReport field.
func (o *GroupMailProperties) SetDeliveryFailureReport(v DeliveryFailureReportType) {
	o.DeliveryFailureReport = &v
}

// GetGroupId returns the GroupId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *GroupMailProperties) GetGroupId() string {
	if o == nil || IsNil(o.GroupId.Get()) {
		var ret string
		return ret
	}
	return *o.GroupId.Get()
}

// GetGroupIdOk returns a tuple with the GroupId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *GroupMailProperties) GetGroupIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.GroupId.Get(), o.GroupId.IsSet()
}

// HasGroupId returns a boolean if a field has been set.
func (o *GroupMailProperties) HasGroupId() bool {
	if o != nil && o.GroupId.IsSet() {
		return true
	}

	return false
}

// SetGroupId gets a reference to the given NullableString and assigns it to the GroupId field.
func (o *GroupMailProperties) SetGroupId(v string) {
	o.GroupId.Set(&v)
}

// SetGroupIdNil sets the value for GroupId to be an explicit nil
func (o *GroupMailProperties) SetGroupIdNil() {
	o.GroupId.Set(nil)
}

// UnsetGroupId ensures that no value is present for GroupId, not even an explicit nil
func (o *GroupMailProperties) UnsetGroupId() {
	o.GroupId.Unset()
}

// GetPrimaryMailAlias returns the PrimaryMailAlias field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *GroupMailProperties) GetPrimaryMailAlias() string {
	if o == nil || IsNil(o.PrimaryMailAlias.Get()) {
		var ret string
		return ret
	}
	return *o.PrimaryMailAlias.Get()
}

// GetPrimaryMailAliasOk returns a tuple with the PrimaryMailAlias field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *GroupMailProperties) GetPrimaryMailAliasOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.PrimaryMailAlias.Get(), o.PrimaryMailAlias.IsSet()
}

// HasPrimaryMailAlias returns a boolean if a field has been set.
func (o *GroupMailProperties) HasPrimaryMailAlias() bool {
	if o != nil && o.PrimaryMailAlias.IsSet() {
		return true
	}

	return false
}

// SetPrimaryMailAlias gets a reference to the given NullableString and assigns it to the PrimaryMailAlias field.
func (o *GroupMailProperties) SetPrimaryMailAlias(v string) {
	o.PrimaryMailAlias.Set(&v)
}

// SetPrimaryMailAliasNil sets the value for PrimaryMailAlias to be an explicit nil
func (o *GroupMailProperties) SetPrimaryMailAliasNil() {
	o.PrimaryMailAlias.Set(nil)
}

// UnsetPrimaryMailAlias ensures that no value is present for PrimaryMailAlias, not even an explicit nil
func (o *GroupMailProperties) UnsetPrimaryMailAlias() {
	o.PrimaryMailAlias.Unset()
}

// GetGroupsAllowedToPost returns the GroupsAllowedToPost field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *GroupMailProperties) GetGroupsAllowedToPost() []GroupInfo {
	if o == nil {
		var ret []GroupInfo
		return ret
	}
	return o.GroupsAllowedToPost
}

// GetGroupsAllowedToPostOk returns a tuple with the GroupsAllowedToPost field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *GroupMailProperties) GetGroupsAllowedToPostOk() ([]GroupInfo, bool) {
	if o == nil || IsNil(o.GroupsAllowedToPost) {
		return nil, false
	}
	return o.GroupsAllowedToPost, true
}

// HasGroupsAllowedToPost returns a boolean if a field has been set.
func (o *GroupMailProperties) HasGroupsAllowedToPost() bool {
	if o != nil && !IsNil(o.GroupsAllowedToPost) {
		return true
	}

	return false
}

// SetGroupsAllowedToPost gets a reference to the given []GroupInfo and assigns it to the GroupsAllowedToPost field.
func (o *GroupMailProperties) SetGroupsAllowedToPost(v []GroupInfo) {
	o.GroupsAllowedToPost = v
}

// GetIdentitiesAllowedToPost returns the IdentitiesAllowedToPost field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *GroupMailProperties) GetIdentitiesAllowedToPost() []IdentityInfo {
	if o == nil {
		var ret []IdentityInfo
		return ret
	}
	return o.IdentitiesAllowedToPost
}

// GetIdentitiesAllowedToPostOk returns a tuple with the IdentitiesAllowedToPost field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *GroupMailProperties) GetIdentitiesAllowedToPostOk() ([]IdentityInfo, bool) {
	if o == nil || IsNil(o.IdentitiesAllowedToPost) {
		return nil, false
	}
	return o.IdentitiesAllowedToPost, true
}

// HasIdentitiesAllowedToPost returns a boolean if a field has been set.
func (o *GroupMailProperties) HasIdentitiesAllowedToPost() bool {
	if o != nil && !IsNil(o.IdentitiesAllowedToPost) {
		return true
	}

	return false
}

// SetIdentitiesAllowedToPost gets a reference to the given []IdentityInfo and assigns it to the IdentitiesAllowedToPost field.
func (o *GroupMailProperties) SetIdentitiesAllowedToPost(v []IdentityInfo) {
	o.IdentitiesAllowedToPost = v
}

// GetMailAliases returns the MailAliases field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *GroupMailProperties) GetMailAliases() []string {
	if o == nil {
		var ret []string
		return ret
	}
	return o.MailAliases
}

// GetMailAliasesOk returns a tuple with the MailAliases field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *GroupMailProperties) GetMailAliasesOk() ([]string, bool) {
	if o == nil || IsNil(o.MailAliases) {
		return nil, false
	}
	return o.MailAliases, true
}

// HasMailAliases returns a boolean if a field has been set.
func (o *GroupMailProperties) HasMailAliases() bool {
	if o != nil && !IsNil(o.MailAliases) {
		return true
	}

	return false
}

// SetMailAliases gets a reference to the given []string and assigns it to the MailAliases field.
func (o *GroupMailProperties) SetMailAliases(v []string) {
	o.MailAliases = v
}

func (o GroupMailProperties) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o GroupMailProperties) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if o.Id.IsSet() {
		toSerialize["id"] = o.Id.Get()
	}
	if !IsNil(o.AllowAuthenticatedMessagesOnly) {
		toSerialize["allowAuthenticatedMessagesOnly"] = o.AllowAuthenticatedMessagesOnly
	}
	if !IsNil(o.EnableArchive) {
		toSerialize["enableArchive"] = o.EnableArchive
	}
	if !IsNil(o.DeliveryFailureReport) {
		toSerialize["deliveryFailureReport"] = o.DeliveryFailureReport
	}
	if o.GroupId.IsSet() {
		toSerialize["groupId"] = o.GroupId.Get()
	}
	if o.PrimaryMailAlias.IsSet() {
		toSerialize["primaryMailAlias"] = o.PrimaryMailAlias.Get()
	}
	if o.GroupsAllowedToPost != nil {
		toSerialize["groupsAllowedToPost"] = o.GroupsAllowedToPost
	}
	if o.IdentitiesAllowedToPost != nil {
		toSerialize["identitiesAllowedToPost"] = o.IdentitiesAllowedToPost
	}
	if o.MailAliases != nil {
		toSerialize["mailAliases"] = o.MailAliases
	}
	return toSerialize, nil
}

type NullableGroupMailProperties struct {
	value *GroupMailProperties
	isSet bool
}

func (v NullableGroupMailProperties) Get() *GroupMailProperties {
	return v.value
}

func (v *NullableGroupMailProperties) Set(val *GroupMailProperties) {
	v.value = val
	v.isSet = true
}

func (v NullableGroupMailProperties) IsSet() bool {
	return v.isSet
}

func (v *NullableGroupMailProperties) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGroupMailProperties(val *GroupMailProperties) *NullableGroupMailProperties {
	return &NullableGroupMailProperties{value: val, isSet: true}
}

func (v NullableGroupMailProperties) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGroupMailProperties) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
